#include <stdio.h>

struct sNo
{
    int         Info;
    struct sNo* Prox;
};

struct sNo* Insira (struct sNo* Inicio, int Numero)
{
    if (Inicio == NULL)
    {
	struct sNo* Novo = (struct sNo*) malloc (sizeof (struct sNo));

	Novo -> Info = Numero;
	Novo -> Prox = NULL;

	return Novo;
    }
    else
	if (Numero < Inicio -> Info)
	{
	    struct sNo* Novo = (struct sNo*) malloc (sizeof (struct sNo));

	    Novo -> Info = Numero;
	    Novo -> Prox = Inicio;

	    return Novo;
	}
	else
	{
	    Inicio -> Prox = Insira (Inicio -> Prox, Numero);
	    return Inicio;
	}
}

struct sNo* Remova (struct sNo* Inicio, int Numero)
{
    if (Inicio == NULL)
	return Inicio;
    else
	if (Inicio -> Info == Numero)
	{
	    struct sNo* Removido = Inicio;
	    Inicio = Inicio -> Prox;
	    free (Removido);
	    return Remova (Inicio, Numero);
	}
	else
	{
	    Inicio -> Prox = Remova (Inicio -> Prox, Numero);
	    return Inicio;
	}
}

void Imprima (struct sNo* Inicio)
{
    if (Inicio == NULL)
	printf ("{}\n");
    else
    {
	printf ("{");

	for (; Inicio != NULL; Inicio = Inicio -> Prox)
	    printf ("%d, ", Inicio -> Info);

	printf ("\b\b}\n");
    }
}

void main ()
{
    struct sNo* Inicio = NULL;
    Imprima (Inicio);

    Inicio = Insira (Inicio, 3);
    Imprima (Inicio);

    Inicio = Insira (Inicio, 1);
    Imprima (Inicio);

    Inicio = Insira (Inicio, 2);
    Imprima (Inicio);

    Inicio = Remova (Inicio, 2);
    Imprima (Inicio);
}